#import "OxOnekeyFlutterPlugin.h"


#define TEST_ISIPHONEX \
({BOOL isPhoneX = NO;\
if ([UIDevice currentDevice].systemVersion.floatValue >= 11.0) {\
isPhoneX = [[UIApplication sharedApplication] delegate].window.safeAreaInsets.bottom > 0.0;\
}\
(isPhoneX);})
#define NavHeight (TEST_ISIPHONEX ? 88 : 64)
#define TEST_HEXCOLOR(hex) [UIColor colorWithRed:((float)((hex & 0xFF0000) >> 16)) / 255.0 green:((float)((hex & 0xFF00) >> 8)) / 255.0 blue:((float)(hex & 0xFF)) / 255.0 alpha:1]
#define getRectNavAndStatusHight  (self.navigationController.navigationBar.frame.size.height+[[UIApplication sharedApplication] statusBarFrame].size.height)
#define TEST_SCREEN_WIDTH   [UIScreen mainScreen].bounds.size.width
#define TEST_SCREENH_HEIGHT [UIScreen mainScreen].bounds.size.height
#define TEST_SCREEN_WIDTH_RATIO TEST_SCREEN_WIDTH/375
#define TEST_SCREENH_HEIGHT_RATIO TEST_SCREENH_HEIGHT/667

#import <OXSaiSDK/OXSaiSDK.h>
@interface OxOnekeyFlutterPlugin()<OXActionDelegate>
@property (nonatomic,strong)FlutterResult initResult;
@property (nonatomic,strong)FlutterResult oneKeyResult;
@property (nonatomic,strong)FlutterResult mobileAuthResult;
@property (nonatomic,strong)FlutterResult preLoginResult;
@end

@implementation OxOnekeyFlutterPlugin

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    FlutterMethodChannel *channel = [FlutterMethodChannel
               methodChannelWithName:@"ox_onekey_flutter"
                     binaryMessenger:[registrar messenger]];
    OxOnekeyFlutterPlugin *instance = [[OxOnekeyFlutterPlugin alloc] init];
    [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall *)call result:(FlutterResult)result {
    if ([@"getSdkVersion" isEqualToString:call.method]) {

        result([OXClientEntry sdkVersion]);

    }else if ([@"oxNetworkInfo" isEqualToString:call.method]){

        result([OXClientEntry networkInfo]);

    }else if ([@"oxInitSaiSDK" isEqualToString:call.method]){
        self.initResult = result;
        [self initSAIWithParams:call.arguments];

    }else if ([@"oxOnekeyLogin" isEqualToString:call.method]){
        self.oneKeyResult = result;
        [OXClientEntry oneKeyCustomUIWithParams:[self portraitModel]];//弹框范例--范例支持横竖屏切换
        UIViewController *vc = [self appRootViewController];
        [OXClientEntry requestAction:OXActionTypeGetOnekeyLoginToken params:@{OXCurrentVC:vc,@"timeout":@"5"}];

    }else if ([@"oxMobileAuth" isEqualToString:call.method]){
        self.mobileAuthResult = result;
        [OXClientEntry requestAction:OXActionTypeGetMobileAuthToken params:nil];

    }else if ([@"oxPreLogin" isEqualToString:call.method]){
        self.preLoginResult = result;
        [OXClientEntry requestAction:OXActionTypePreLogin params:nil];

    }else if ([@"oxDismissLoginPage" isEqualToString:call.method]){

         [OXClientEntry dismissLoginPageAnimated:YES completion:nil];

    }else {
        result(FlutterMethodNotImplemented);
    }
}
#pragma mark - 回调
/**
 SDK初始化回调
 @param response 返回的response
 如果respose.code为00000代表成功
 */
-(void)oxActionInitSdkResponse:(NSDictionary *)response{
    self.initResult(response);
}

/**
 功能服务回调

 @param result 回调结果
 */
-(void)onActionResult:(NSDictionary *)result{
    NSString *code = [NSString stringWithFormat:@"%@",result[@"result"][@"code"]];
    NSInteger action_type = [[result valueForKey:@"action_type"] integerValue];
    switch (action_type) {
        case OXActionTypeGetOnekeyLoginToken:
            if(![code isEqualToString:@"45033"]){
                self.oneKeyResult(result);
            }
            break;
        case OXActionTypeGetMobileAuthToken:
                self.mobileAuthResult(result);
            break;
        case OXActionTypePreLogin:
                self.preLoginResult(result);
            break;
        default:
            break;
    }
}


#pragma mark 全屏model

-(OXOneKeyCustomModel *)portraitModel{

    OXOneKeyCustomModel *model = [[OXOneKeyCustomModel alloc] init];
    model.oxNavigationBarStyle = @(UIBarStyleDefault);
    model.oxAppTermsWebNavigationBarStyle =@(UIBarStyleDefault);
    model.oxSupportedInterfaceOrientations = @(UIInterfaceOrientationMaskAll);
    model.oxShouldAutorotate = @(NO);
    model.oxShouldAutorotate = @(NO);
    model.oxNavigationBackgroundoxear = @(YES);
    model.oxLogoHiden = @(YES);
    model.oxPhoneNumberColor = [UIColor blackColor];
    model.oxPhoneNumberFont = [UIFont systemFontOfSize:35];
    model.oxLoginBtnText = @"本机号码一键登录";
    model.oxLoginBtnTextColor = TEST_HEXCOLOR(0xffffff) ;
    model.oxLoginBtnBgColor = TEST_HEXCOLOR(0x3D7EFF);
    model.oxLoginBtnTextFont = [UIFont systemFontOfSize:19];
    model.oxLoginBtnCornerRadius = @(0);
    model.oxSloganTextFont = [UIFont systemFontOfSize:12];
    model.oxSloganTextColor = [UIColor grayColor];
    model.oxAppTermsColor = @[TEST_HEXCOLOR(0x3D7EFF),[UIColor grayColor]];
    model.oxCheckBoxValue= @(YES);
    model.oxOrientationLayOutPortrait = [self setLayoutPortrait];
    return model;
}
#pragma mark 全屏Layout
//竖屏
-(OXOrientationLayOut *)setLayoutPortrait{
    CGFloat ratio;
    if (TEST_SCREEN_WIDTH>TEST_SCREENH_HEIGHT) {
        ratio = TEST_SCREENH_HEIGHT/375;
    }else{
        ratio = TEST_SCREEN_WIDTH/375;
    }
    OXOrientationLayOut *oxOrientationLayOutPortrait = [OXOrientationLayOut new];
    oxOrientationLayOutPortrait.oxLayoutPhoneTop = @(ratio*120);
    oxOrientationLayOutPortrait.oxLayoutPhoneWidth = @(200);
    oxOrientationLayOutPortrait.oxLayoutPhoneHeight = @(40);
    oxOrientationLayOutPortrait.oxLayoutPhoneCenterX = @(0);

    oxOrientationLayOutPortrait.oxLayoutSloganTop = @(ratio*150+10);
    oxOrientationLayOutPortrait.oxLayoutSloganWidth = @(300);
    oxOrientationLayOutPortrait.oxLayoutSloganHeight = @(20);
    oxOrientationLayOutPortrait.oxLayoutSloganCenterX = @(0);

    oxOrientationLayOutPortrait.oxLayoutLoginBtnTop = @(ratio*180+10);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnWidth = @(ratio*310);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnHeight = @(45);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnCenterX = @(0);

    oxOrientationLayOutPortrait.oxLayoutAppTermsTop = @(ratio*190+10+45+5);
    oxOrientationLayOutPortrait.oxLayoutAppTermsWidth = @(ratio*280);
    oxOrientationLayOutPortrait.oxLayoutAppTermsCenterX = @(0);

    return oxOrientationLayOutPortrait;
}

/// 初始化秒验SDK
- (void)initSAIWithParams:(NSDictionary *)params{
    [OXClientEntry printConsoleEnable:YES];
    [OXClientEntry initWithParams:params delegate:self];
}
- (UIViewController *)appRootViewController
{
    UIViewController *RootVC = [UIApplication sharedApplication].keyWindow.rootViewController;
    UIViewController *topVC = RootVC;
    while (topVC.presentedViewController) {
        topVC = topVC.presentedViewController;
    }
    return topVC;
}
@end
